/*  
    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#include <iostream>
#include <list>
#include "htn.h"
#include "../../h/conf.h"
#include "../../mpg/h/mpg.h"
#include "reduction.h"

/* Solver interface header, 
it allows the following:
1. decide whether an HTN @htn is consistent or not
2. if @htn is consistent, compute a feasible scheduling 
3. otherwise, compute a negative cycle of @htn */

bool is_consistent(HyperTemporalNetwork* htn);
t_feasible_sched* compute_feasible_sched(HyperTemporalNetwork* htn);
t_feasible_sched* compute_feasible_sched(MeanPayoffGame* mpg, unsigned long* energy);
t_feasible_sched* compute_feasible_sched_BFTest(MeanPayoffGame* mpg);
t_neg_cycle* compute_neg_cycle(HyperTemporalNetwork* htn);
t_neg_cycle* compute_neg_cycle(HyperTemporalNetwork* htn, MeanPayoffGame* mpg, bool* decision);
