/* 
    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#include "../../h/mpg.h"
#include "../../../h/conf.h"

class ZwickPaterson1996Algorithm{
	private:
	MeanPayoffGame* mpg;

	public:
	ZwickPaterson1996Algorithm(MeanPayoffGame *mpg);
	~ZwickPaterson1996Algorithm();
	
	bool* solve_decision();
	t_rational* solve_opt_values();
	t_rational search_for_rational(long long nu_k, unsigned long K);
	long long* compute_nu_k(unsigned long size, unsigned long long K);
	t_w_arc* compute_winning_strategy(unsigned int p);
	t_w_arc* compute_optimal_strategy();
	t_w_arc binary_search_optimal_arc(unsigned long u, t_rational v); 
	t_w_arc binary_search_winning_arc(unsigned long u, int p);
};
